// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package device

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jaryhe/gopkgs/logger"
	"go.uber.org/zap"
	"smart-supplier-management/errors"
	"smart-supplier-management/model"
	"smart-supplier-management/pb/v1"
	"time"
)


func ChannelUpdate(ctx context.Context, req *v1.ChannelUpdateRequest) (reply *v1.ChannelUpdateReply, err error) {
	if req.Id < 1{
		return nil, errors.ParamsError
	}

	p := model.Vsschanneltbl{}
	where := map[string]interface{}{
		"id":req.Id,
	}
	value := map[string]interface{}{
		"Nickname":req.Name,
		"UpdateTime":time.Now(),
	}
	err = p.Update(database.DB(), where, value)
	if err != nil {
		logger.Error("ChannelUpdate",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	projectId, _ := model.GetProjectIdByChannel(database.DB(), req.Id)
	reply = &v1.ChannelUpdateReply{ProjectId:projectId}
	return reply, nil


}
