// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package device

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"smart-supplier-management/errors"
	"smart-supplier-management/model"
	"smart-supplier-management/pb/v1"
	"github.com/jaryhe/gopkgs/logger"
	"go.uber.org/zap"
)

func ProjectList(ctx context.Context, req *v1.ProjectListRequest) (reply *v1.ProjectListReply, err error) {
	reply = &v1.ProjectListReply{}

	p := model.TProject{}
	list, err := p.List(database.DB(), nil)
	if err != nil {
		logger.Error("ProjectList",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}

	reply.List = make([]*v1.ProjectItem, len(list))
	for i, v := range list{
		item := &v1.ProjectItem{
			Id:v.ID,
			Name:v.Name,
			ShortName:v.ShortName,
			SafetyRecordNo:v.SafetyRecordNo,
			ProjectNo:v.ProjectNo,
		}
		reply.List[i] = item
	}

	return reply, nil
}
